import time
from fischertechnik.controller.Motor import Motor
from lib.controller import *
from lib.machine_learning import *

MovementSpeedCam = None
MovementSpeed = None
posWHITE = None
posBLUE = None
posCam = None
i = None
posFinish = None
num = None


def thread_SLD():
    global MovementSpeedCam, MovementSpeed, posWHITE, posBLUE, posCam, i, posFinish, num
    print('starting thread SLD')
    MovementSpeedCam = 300
    MovementSpeed = 512
    posWHITE = 11
    posBLUE = 27
    posCam = 42
    posFinish = 300
    num = -1
    while True:
        mainSLDexternal()


def moveRefM2():
    global MovementSpeedCam, MovementSpeed, posWHITE, posBLUE, posCam, i, posFinish, num
    TXT_SLD_M_M2_encodermotor.set_speed(int(200), Motor.CW)
    TXT_SLD_M_M2_encodermotor.start()
    while True:
        if (TXT_SLD_M_I2_mini_switch.is_closed()):
            break
        time.sleep(0.010)
    TXT_SLD_M_M2_encodermotor.stop()


def mainSLDexternal():
    global MovementSpeedCam, MovementSpeed, posWHITE, posBLUE, posCam, i, posFinish, num
    if TXT_SLD_M_I1_photo_transistor.is_dark():
        moveRefM2()
        reset_inteface()
        print('start')
        TXT_SLD_M_M1_encodermotor.set_speed(int(MovementSpeed * 0.5), Motor.CCW)
        TXT_SLD_M_M1_encodermotor.start_sync()
        for i in (0 <= posCam) and upRange(0, posCam, 1) or downRange(0, posCam, 1):
            if not (TXT_SLD_M_I1_photo_transistor.is_dark()):
                break
            time.sleep(0.01)
        TXT_SLD_M_M1_encodermotor.stop_sync()
        TXT_SLD_M_M1_encodermotor.set_speed(int(MovementSpeedCam), Motor.CCW)
        TXT_SLD_M_M1_encodermotor.set_distance(int(posCam))
        while True:
            if (not TXT_SLD_M_M1_encodermotor.is_running()):
                break
            time.sleep(0.010)
        print('pos camera')
        num = MakePictureRunKiReturnFoundPart()
        if num == 1:
            TXT_SLD_M_M2_encodermotor.set_speed(int(300), Motor.CCW)
            TXT_SLD_M_M2_encodermotor.set_distance(int(posWHITE))
            while True:
                if (not TXT_SLD_M_M2_encodermotor.is_running()):
                    break
                time.sleep(0.010)
            TXT_SLD_M_M1_encodermotor.set_speed(int(MovementSpeed), Motor.CCW)
            TXT_SLD_M_M1_encodermotor.set_distance(int(posFinish))
            while True:
                if (not TXT_SLD_M_M1_encodermotor.is_running()):
                    break
                time.sleep(0.010)
        elif num == 3:
            print('BLUE')
            TXT_SLD_M_M2_encodermotor.set_speed(int(300), Motor.CCW)
            TXT_SLD_M_M2_encodermotor.set_distance(int(posBLUE))
            while True:
                if (not TXT_SLD_M_M2_encodermotor.is_running()):
                    break
                time.sleep(0.010)
            TXT_SLD_M_M1_encodermotor.set_speed(int(MovementSpeed), Motor.CCW)
            TXT_SLD_M_M1_encodermotor.set_distance(int(posFinish))
            while True:
                if (not TXT_SLD_M_M1_encodermotor.is_running()):
                    break
                time.sleep(0.010)
        else:
            print('FAIL')
            moveRefM2()
            TXT_SLD_M_M1_encodermotor.set_speed(int(MovementSpeed), Motor.CCW)
            TXT_SLD_M_M1_encodermotor.set_distance(int(posFinish))
            while True:
                if (not TXT_SLD_M_M1_encodermotor.is_running()):
                    break
                time.sleep(0.010)


def upRange(start, stop, step):
    while start <= stop:
        yield start
        start += abs(step)
def downRange(start, stop, step):
    while start >= stop:
        yield start
        start -= abs(step)
